//+------------------------------------------------------------------+
//|                      Scooby-doo ADR OB_OS auto trading robot.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property show_inputs
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define high "High"
#define low "Low"
#define SAR_High "SAR_High"
#define SAR_Low "SAR_Low"
#define exhaustion "Exhaustion"
#define sar "Stop and reverse"
#define gv " ADR SAR "


/*
www.forexpros.com
	

void DisplayUserFeedback()
int start()
void GetPosition()
bool NewsExist()    not used in this robot
void SendOrder(string symbol, int type, double lots, string comment)
bool DoesTradeExist(string symbol)

----ADR & B Bands----
double Get_ADR(string symbol)
double Get_Trade_Entry_Points(string symbol, int range, string direction)
void ReadBands(string symbol)

----Trade management----
void ManageTrades()
void ShouldTradeHalfClose()
bool Should_SAR_Trade_Close()


----Pairs traded----
void CleanUpInputString()
void CalculatePairsPassed()

*/


extern string  PairsToTrade = "AUDJPY,AUDUSD,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURJPY,EURUSD,GBPJPY,GBPUSD,USDCAD,USDCHF,USDJPY";
extern double  Lots = 0.02;
extern int     MagicNumber = 4971887;
//extern string  TradeComment="Adr";
extern bool    CriminalIsECN=false;
extern int     MaxTradesAllowed=6;
extern int     PendingTradesPipsDistance=150;
extern int     PendingTradesExpireMinutes=60;
extern string  trd="----Allowable trade directions----";
extern bool    TradeLong=false;
extern bool    TradeShort=false;
extern bool    StopTrading=false;
extern string  adrs="----ADR & Bollinger Bands settings----";
extern int     AdrPeriod=10;
extern int     Min_ADR=200;
extern string  p1="Enter the chart time frame in minutes";
extern string  p2="D1 = 1440; W1 = 10080; M1 = 40320";
extern int     Chart_TF=1440;
extern string  b1="Enter the Bollinger Bands time frame in minutes";
extern int     BB_TF=60;
extern string  sltp1="SL and TP are a percentage of";
extern string  sltp2="the average daily range";
extern int     TP_Percent=40;
extern int     SL_Percent=20;
extern string  tt="----Trading hours----";
extern string  Trade_Hours= "Set Morning & Evening Hours 24hr";
extern string  Trade_Hours_M= "Morning Hours 0-12";
extern  int    start_hourm = 0;
extern  int    end_hourm = 12;
extern string  Trade_Hours_E= "Evening Hours 12-24";
extern  int    start_houre = 12;
extern  int    end_houre = 24;
extern string  wei="----Week ending inputs----";
extern bool    FridayClose=true;
extern bool    SaturdayClose=false;
extern int     CloseHour = 12;
extern string  oae="----Odds and ends----";
extern int     DisplayGapSize=30;
extern bool    ShowPairsInformation=true;
extern bool    ShowAlerts=true;




//Trading
int      TicketNo;
int      NoOfTrades;
string   GvName;//Global variable that keeps track of sar trades to stop more than one a day

//Trading hours
bool     ClosedForFriday;
bool     ClosedForSaturday;

//Bands - counts from the top down
double   Line1;
double   Line2;
double   Line3;


//Pair extraction
string   InputString;//Holds the contents PairsToTrade for tidying yp etc
int      NoOfPairs;// Holds the number of pairs passed by the user via the inputs screen
string   TradePair[]; //Array to hold the pairs traded by the user
double   Adr[];//Array to hold each pair's adr to save on cpu processing time
double   TradeEntryHigh[];
double   TradeEntryLow[];
double   SarEntryHigh[];
double   SarEntryLow[];
int      dBars[];
int      bBars[];//For Bollinger Bands bars

//Misc stuff
int      Decimals, OldBars, OldBollingerBars;
string   Trend, ScreenMessage, Gap;
bool     RobotDisabled;
string   DisabledMessage;


void DisplayUserFeedback()
{

   ScreenMessage = "";
   int cc;
   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading ", PairsToTrade, NL);
   if (TradeLong) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Taking long trades ", NL);
   if (TradeShort) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Taking long trades ", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lots, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Magic number: ", MagicNumber, NL);
   //ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trade comment: ", TradeComment, NL);
   if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN is true ", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN is false ", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour start = ", start_hourm, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour end = ", end_hourm, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour start = ", start_houre, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour end = ", end_houre, NL);
   if (FridayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Friday close = ", DoubleToStr(CloseHour, 2), NL);
   if (SaturdayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Saturday close = ", DoubleToStr(CloseHour, 2), NL);
   if (ClosedForSaturday) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Saturday close. Continuing to monitor open trades.", NL);
   if (ClosedForFriday) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Friday close. Continuing to monitor open trades.", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Pending pips distance = ", PendingTradesPipsDistance, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Pending trades expiry = ", PendingTradesExpireMinutes, " minutes", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AdrPeriod = ", AdrPeriod, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Minimum tradable ADR = ", Min_ADR, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Chart time frame = ", Chart_TF, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Bollinger Bands time frame = ", BB_TF, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
      
   if (ShowPairsInformation)
   {
      for (cc = 0; cc < NoOfPairs; cc++)
      {
         int digits = MarketInfo(TradePair[cc], MODE_DIGITS);
         ScreenMessage = StringConcatenate(ScreenMessage, Gap, TradePair[cc], "    ", Adr[cc], 
                         ": Entry high = ", DoubleToStr(TradeEntryHigh[cc], digits), 
                         ": Entry low = ", DoubleToStr(TradeEntryLow[cc], digits), 
                         ": SAR high = ", DoubleToStr(SarEntryHigh[cc], digits), 
                         ": SAR low = ", DoubleToStr(SarEntryLow[cc], digits),  
                          NL);
      }//for (cc = 0; cc < NoOfCurrencies; cc==)
   }//if (ShowPairsInformation)

   Comment(ScreenMessage);
   
}//End void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert Initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {

   if (!IsDemo() )
   {
      if (MagicNumber == 4971887)
      {
         MessageBox("You cannot run this robot until changed the MagicNumber input from the default of 4971887." + NL 
                    + "Please reload the robot with a new MagicNumber input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the MagicNumber input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 4872635)
      
      //Insufficient length
      string mn = DoubleToStr(MagicNumber,0);
      if (StringLen(mn) < 5)
      {
         MessageBox("Your MagicNumber input needs to be at least 5 digits long, Your MagicNumber is " + mn + NL 
                    + "Please reload the robot with the MagicNumber input containing at least 5 digits - the more the better.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to make the MagicNumber input at 5 digits long - more is better";
         RobotDisabled = true;
         return;
      }//if (StringLen(mn) < 5)     
      
   }//if (!IsDemo)
   
   
   //Amend inputs to cater for different broker digits
   int dig = MarketInfo(Symbol(), MODE_DIGITS);
   if (dig == 2 || dig == 4)
   {   
      PendingTradesPipsDistance/= 10;      
   }//if (dig = 3)
   
   //Extract the pairs traded by the user
   // Cleanup first
   InputString=PairsToTrade;
   CleanUpInputString();
   
   // Extract the number of paraaters passed by the user
   CalculatePairsPassed();
   
   string AddChar = StringSubstr(Symbol(),6,4);
   
   // Resize the arrays appropriately
   string NewArray = ArrayResize(TradePair, NoOfPairs);
   double dNewAwway = ArrayResize(Adr, NoOfPairs);
   double dNew1 = ArrayResize(TradeEntryHigh, NoOfPairs);
   double dNew2 = ArrayResize(TradeEntryLow, NoOfPairs);
   double iNew3 = ArrayResize(dBars, NoOfPairs);
   double iNew4 = ArrayResize(SarEntryHigh, NoOfPairs);
   double iNew5 = ArrayResize(SarEntryLow, NoOfPairs);
   int iNew6  = ArrayResize(bBars, NoOfPairs);
   
   int Index = 0;//For searching InputString
   int LastIndex = 0;//Points the the most recent Index
   for (int cc = 0; cc < NoOfPairs; cc ++)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         TradePair[cc] = StringSubstr(InputString, LastIndex,Index-LastIndex);
         TradePair[cc] = StringTrimLeft(TradePair[cc]);
         TradePair[cc] = StringTrimRight(TradePair[cc]);
         TradePair[cc] = StringConcatenate(TradePair[cc], AddChar);
         
         LastIndex = Index+1;
         dBars[cc] = iBars(TradePair[cc], Chart_TF);
         bBars[cc] = iBars(TradePair[cc], BB_TF);
         //Stop the robot trading before the start of the new candle
         GvName = gv + TradePair[cc];
         GlobalVariableSet(GvName, 0);
      }//if (Index > -1)            
   }//for (int cc; cc<NoOfPairs; cc ++)

    int Step = MarketInfo(Symbol(),MODE_LOTSTEP);
    
    if(Step == 0.01) Decimals = 2;
    if(Step == 0.10) Decimals = 1;
    if(Step == 1.00) Decimals = 0;
    
    
   Gap="";
   if (DisplayGapSize >0)
   {
      for (cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }
   
   GetPosition();   
   if (NoOfTrades == 0) OldBars = iBars(NULL, Chart_TF);

   for (cc = 0; cc < ArraySize(TradePair); cc++)
   {
      Adr[cc] = Get_ADR(TradePair[cc] );
      TradeEntryHigh[cc] = Get_Trade_Entry_Points(TradePair[cc], Adr[cc], high);
      TradeEntryLow[cc] = Get_Trade_Entry_Points(TradePair[cc], Adr[cc], low);
      SarEntryHigh[cc] = Get_Trade_Entry_Points(TradePair[cc], Adr[cc], SAR_High);
      SarEntryLow[cc] = Get_Trade_Entry_Points(TradePair[cc], Adr[cc], SAR_Low);
   }//for (cc = 0; cc < ArraySize(TradePair); cc++)

   
   Comment(".........Waiting for a tick");
   
   return(0);
    
  }
  
//+------------------------------------------------------------------+
//| expert Deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
  {

    Comment("");
    
    return(0);

  }
  
//+------------------------------------------------------------------+
//| expert GetPosition function                                      |
//+------------------------------------------------------------------+

void GetPosition()
{

   NoOfTrades = 0;
   if (OrdersTotal() == 0 ) return;
   
   for(int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
       if(!OrderSelect(cc, SELECT_BY_POS, MODE_TRADES) ) continue;
         
       if(OrderMagicNumber() == MagicNumber)
       {
           NoOfTrades++;
       }//if(OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber)
         
   }//for(int cc = 0; cc <= OrdersTotal(); cc++)
 
 
}//void GetPosition(string symbol)


//+------------------------------------------------------------------+
//| expert SendOrder function                                        |
//+------------------------------------------------------------------+  

void SendOrder(string symbol, int type, double lots, string comment) 
{
    double price;
    double point = MarketInfo(symbol,MODE_POINT);
    double digits = MarketInfo(symbol,MODE_DIGITS);
    double sl;
    double tp;

    int ticket = -1;
    int spread = 10;
        
    if(digits == 3 || digits == 5)
      {
        spread *= 10;
      }
    
   //Trade expiry time
   datetime OrderExpiryTime = TimeCurrent();
   OrderExpiryTime += PendingTradesExpireMinutes * 60;
  
   double AdrVal = Get_ADR(symbol);
   if (comment == exhaustion)
   {
      int SlPips = AdrVal * SL_Percent / 100;
      int TpPips = AdrVal * TP_Percent / 100;
   }//if (comment == exhaustion)
    
   if (comment == sar)
   {
      SlPips = AdrVal * 25 / 100;      
   }//if (comment == sar)
    
      
   if(type == OP_BUYSTOP)
   {
     
      RefreshRates();
      price  = NormalizeDouble(MarketInfo(symbol,MODE_ASK) + (PendingTradesPipsDistance * point), digits);
      sl = NormalizeDouble(price - (SlPips * point), digits);
      if (!CriminalIsECN) ticket = OrderSend(symbol,OP_BUYSTOP,lots,price,3,sl,tp,comment,MagicNumber,OrderExpiryTime,CLR_NONE);
      if (CriminalIsECN) ticket = OrderSend(symbol,OP_BUYSTOP,lots,price,3,0,0,comment,MagicNumber,OrderExpiryTime,CLR_NONE);
      
      Sleep(1000);
       
       if (CriminalIsECN && ticket > -1)
         {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool result = OrderModify(ticket, OrderOpenPrice(),	sl, tp, OrderExpiration(), CLR_NONE);
		      if (!result)
		      {
		          int err=GetLastError();
                if (ShowAlerts) Alert(Symbol(), " Buy TP order modify failed with error(",err,"): ",ErrorDescription(err));
		      }//if (!result)
         }
   }//if(type == OP_BUYSTOP)
      
   if(type == OP_BUY)
   {
     
      RefreshRates();
      price  = NormalizeDouble(MarketInfo(symbol,MODE_ASK), digits);
      sl = NormalizeDouble(price - (SlPips * point), digits);
      if (!CriminalIsECN) ticket = OrderSend(symbol,type,lots,price,3,sl,0,comment,MagicNumber,0,CLR_NONE);
      if (CriminalIsECN) ticket = OrderSend(symbol,type,lots,price,3,0,0,comment,MagicNumber,0,CLR_NONE);
      
      Sleep(1000);
       
       if (CriminalIsECN && ticket > -1)
         {
            OrderSelect(ticket, SELECT_BY_TICKET);
            result = OrderModify(ticket, OrderOpenPrice(),	sl, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
		      if (!result)
		      {
		          err=GetLastError();
                if (ShowAlerts) Alert(Symbol(), " Buy TP order modify failed with error(",err,"): ",ErrorDescription(err));
		      }//if (!result)
         }
   }//if(type == OP_BUY)
      

   if(type == OP_SELLSTOP)
   {
      RefreshRates();
      price  = NormalizeDouble(MarketInfo(symbol,MODE_BID) - (PendingTradesPipsDistance * point), digits);
      sl = NormalizeDouble(price + (SlPips * point), digits);
      tp = NormalizeDouble(price - (TpPips * point), digits);
      if (!CriminalIsECN) ticket = OrderSend(symbol,OP_SELLSTOP,lots,price,3,sl,tp,comment,MagicNumber,OrderExpiryTime,CLR_NONE);
      if (CriminalIsECN) ticket = OrderSend(symbol,OP_SELLSTOP,lots,price,3,0,0,comment,MagicNumber,OrderExpiryTime,CLR_NONE);            
      Sleep(1000);
       
       if (CriminalIsECN && ticket > -1)
         {
            OrderSelect(ticket, SELECT_BY_TICKET);
            result = OrderModify(ticket, OrderOpenPrice(),	sl, tp, OrderExpiration(), CLR_NONE);
		      if (!result)
		      {
		          err=GetLastError();
                if (ShowAlerts) Alert(Symbol(), " Sell TP order modify failed with error(",err,"): ",ErrorDescription(err));
		      }//if (!result)
         }
   }//if(type == OP_SELLSTOP)

   if(type == OP_SELL)
   {
     
      RefreshRates();
      price  = NormalizeDouble(MarketInfo(symbol,MODE_BID), digits);
      sl = NormalizeDouble(price + (SlPips * point), digits);
      if (!CriminalIsECN) ticket = OrderSend(symbol,type,lots,price,3,sl,0,comment,MagicNumber,OrderExpiryTime,CLR_NONE);
      if (CriminalIsECN) ticket = OrderSend(symbol,type,lots,price,3,0,0,comment,MagicNumber,0,CLR_NONE);
      
      Sleep(1000);
       
       if (CriminalIsECN && ticket > -1)
         {
            OrderSelect(ticket, SELECT_BY_TICKET);
            result = OrderModify(ticket, OrderOpenPrice(),	sl, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
		      if (!result)
		      {
		          err=GetLastError();
                if (ShowAlerts) Alert(Symbol(), " Buy TP order modify failed with error(",err,"): ",ErrorDescription(err));
		      }//if (!result)
         }
   }//if(type == OP_SELL)
      


      if (ticket < 0)
      {
         err=GetLastError();
         if (ShowAlerts) Alert(symbol, " ADR ", type, " ", comment, " order send failed with error(",err,"): ",ErrorDescription(err), " P ", 
                        price, " S ", sl, " T ", tp);
         Print("Order send failed with error(",err,"): ",ErrorDescription(err));
         return(false);
      }//if (ticket < 0)

      if (ticket > -1) NoOfTrades++;//Ensure trades are sent only up to MaxTradesAllowed
}//End void SendOrder(string symbol, int type, double lots, string comment) 

/*
//+------------------------------------------------------------------+
//| expert News function                                             |
//+------------------------------------------------------------------+  

bool NewsExist()
  {
  
    bool News;

    for(int d = 0; d < NoOfPairs; d++)
      {
        int MinutesSincePrevEvent =
          iCustom(NULL,0,"Economic News",TradePair[d],true,false,false,true,true,1,0);

        int MinutesUntilNextEvent =
          iCustom(NULL,0,"Economic News",TradePair[d],true,false,false,true,true,1,1);

        if(MinutesUntilNextEvent < 60 ||
           MinutesSincePrevEvent < 15)
          {
            News = true;
          }
      }
      
    return(News);

  }
*/
//+------------------------------------------------------------------+
//| expert Trend function                                            |
//+------------------------------------------------------------------+  


void CleanUpInputString()
{
   // Does any tidying up of the user inputs
   
   //Remove unwanted spaces
   InputString = StringTrimLeft(InputString);
   InputString = StringTrimRight(InputString);

   //Add final comma if ommitted by user
   if (StringSubstr(InputString, StringLen(InputString)-1) != ",") 
      InputString = StringConcatenate(InputString,",");
      
   
}//void CleanUpInputString

void CalculatePairsPassed()
{
   // Calculates the numbers of paramaters passed in LongMagicNumber and TradeComment.
   
   int Index = 0;//For searching NoTradePairs
   int LastIndex;//Points the the most recent Index
   
   while(Index > -1)
      {
         Index = StringFind(InputString, ",",LastIndex);
         if (Index > -1)
         {
            NoOfPairs ++;
            LastIndex = Index+1;            
         }//if (Index > -1)
      }//while(int cc > -1)
   
   
   
}//End void CalculatePairsPassed()




bool DoesTradeExist(string symbol)
{
   TicketNo=0;
   if (OrdersTotal() == 0) return(false);
   
   for (int cc = OrdersTotal() - 1; cc >=0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderSymbol() == symbol && OrderMagicNumber() ==  MagicNumber)
      {
         TicketNo = OrderTicket();
         return(true);
      }//if (OrderSymbol() == symbol && OrderMagicNumber() ==  MagicNumber)      
   }//for (int cc = OrdersTotal() - 1; cc >=0)
   
   //Got this far, so no trade open
   return(false);

}//End bool DoesTradeExist(string symbol)

void ShouldTradeHalfClose()
{
   //Manage moving stops to be and closing half the trade

   bool result;
   while (!IsTradeAllowed() )
   {
      Comment("Trying to manage trades, but trading not allowed by the criminal");
   }//while (!IsTradeAllowed() )
   string symbol = OrderSymbol();
   if (OrderMagicNumber() ==  MagicNumber && IsTradeAllowed() && OrderLots() > Lots / 2)
   {
      double AdrVal = Get_ADR(symbol);
      double point = MarketInfo(symbol, MODE_POINT);
      double digits =  MarketInfo(symbol, MODE_DIGITS);
      AdrVal*= TP_Percent / 100;
      AdrVal/= 2;
      AdrVal = NormalizeDouble(AdrVal * point, digits);
      
      
      if (OrderProfit() > 0)
      {
         double CloseLots = OrderLots() / 2;
         
         if (OrderType() == OP_BUY)
         {
            //Retry an order modify if a previous attempt to move stop to be failed
            if (OrderLots() < Lots && OrderStopLoss() < OrderOpenPrice() ) result = OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), 0, CLR_NONE);
            double ask = MarketInfo(symbol, MODE_ASK);
            double TargetPrice = NormalizeDouble(OrderOpenPrice() + AdrVal, digits);
            if (ask >= TargetPrice && ask - OrderOpenPrice() > MarketInfo(symbol, MODE_STOPLEVEL) )
            {
               result = OrderClose(OrderTicket(), CloseLots, OrderClosePrice(), 500, CLR_NONE);
               if (!result)
               {
                    int err=GetLastError();
                    if (ShowAlerts) Alert(Symbol(), " Trend retracement robot ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
                    return;
               }//if (!result)
               //Get new ticket number
               Sleep(100);
               DoesTradeExist(symbol);
               OrderSelect(TicketNo, SELECT_BY_TICKET);
               if (OrderStopLoss() < OrderOpenPrice() )
               {
                  result = OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), 0, CLR_NONE);
                  if (!result)
                   {
                       err=GetLastError();
                       if (ShowAlerts) Alert(OrderSymbol(), " Trend retracement robot ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
                       return;
                   }//if (!result)     
               }//if (OrderStopLoss() < OrderOpenPrice() )
            }//if (ask >= TargetPrice && ask - OrderOpenPrice() > MarketInfo(symbol, MODE_STOPLEVEL) )
            
         }//if (OrderType() == OP_BUY)
         
         if (OrderType() == OP_SELL)
         {
            //Retry an order modify if a previous attempt to move stop to be failed
            if (OrderLots() < Lots && OrderStopLoss() > OrderOpenPrice() ) result = OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), 0, CLR_NONE);
            double bid = MarketInfo(symbol, MODE_ASK);
            digits =  MarketInfo(symbol, MODE_DIGITS);
            TargetPrice = NormalizeDouble(OrderOpenPrice() - AdrVal, digits);
            if (bid <= TargetPrice && OrderOpenPrice() - bid  > MarketInfo(symbol, MODE_STOPLEVEL) )
            {   
               result = OrderClose(OrderTicket(), CloseLots, OrderClosePrice(), 500, CLR_NONE);
               if (!result)
               {
                    err=GetLastError();
                    if (ShowAlerts) Alert(OrderSymbol(), " Trend retracement robot ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
                    return;
               }//if (!result)
               //Get new ticket number
               Sleep(100);
               DoesTradeExist(symbol);
               OrderSelect(TicketNo, SELECT_BY_TICKET);
               if (OrderStopLoss() > OrderOpenPrice() )
               {
                  result = OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), 0, CLR_NONE);
                  if (!result)
                   {
                       err=GetLastError();
                       if (ShowAlerts) Alert(Symbol(), " Trend retracement robot ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
                       return;
                   }//if (!result)     
               }//if (OrderStopLoss() < OrderOpenPrice() )
            }//if (bid <= TargetPrice && OrderOpenPrice() - bid  > MarketInfo(symbol, MODE_STOPLEVEL) )
         }//if (OrderType() == OP_SELL)
            
      }//if (OrderProfit() > 0)
      
   }//if (OrderSymbol() == symbol && OrderMagicNumber() ==  MagicNumber)      
}//End void ShouldTradeHalfClose()


void ManageTrades()
{
   //Call the trade management functions one by one

   if (OrdersTotal() == 0) return;
   
   //Deal with exhaustion trades first   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;      
      if (OrderMagicNumber() ==  MagicNumber && IsTradeAllowed() )
      {
         if (OrderLots() > Lots / 2 && OrderComment() == exhaustion) ShouldTradeHalfClose();         
      }//if (OrderMagicNumber() ==  MagicNumber && IsTradeAllowed() )
         
   }//for (int cc = OrdersTotal() - 1; cc >=0)
   
   //Deal with sar trades once an hour (or period chosen by the user)
   //Wait for each new hourly candle to form.
   if (OrdersTotal() == 0) return;
   if (OldBollingerBars != iBars(NULL, BB_TF) )
   {
      bool done = false;
      while (!done)
      {
         done = true;
         for (cc = 0; cc < ArraySize(TradePair); cc++)
         {
            if (bBars[cc] != iBars(TradePair[cc], BB_TF) )
            {
               bBars[cc] = iBars(TradePair[cc], BB_TF);
               done = false;
            }//if (bBars[cc] != iBars(TradePair[cc], BB_TF) )            
         }//for (cc = 0; cc < ArraySize(TradePair); cc++)
      }//while (!done)
      //Cycle through the list of orders and close those that have closed within the bb lines
      if (OrdersTotal() == 0) return;
      for (cc = OrdersTotal() - 1; cc >= 0; cc--)
      {
         if (!OrderSelect(cc, SELECT_BY_POS) ) continue;      
         if (OrderMagicNumber() ==  MagicNumber && IsTradeAllowed() && OrderComment() == sar)
         {
            bool CloseTrade = Should_SAR_Trade_Close();
            if (CloseTrade)
            {
               OrderClose(TicketNo, OrderLots(), OrderClosePrice(), 100);
               Sleep(100);
            }//if (CloseTrade)
               
         }//if (OrderMagicNumber() ==  MagicNumber && IsTradeAllowed() )
         
      }//for (int cc = OrdersTotal() - 1; cc >=0)
      
      OldBollingerBars = iBars(NULL, BB_TF);
   }//if (OldBollingerBars != iBars(NULL, BB_TF)
   
   
}//void ManageTrades()

//+------------------------------------------------------------------+
//| CalculateDailyRange      Average Daily Range                     |
//+------------------------------------------------------------------+
double Get_ADR(string symbol)
{

   double     digits = MarketInfo(symbol, MODE_DIGITS);
   double      point = MarketInfo(symbol, MODE_POINT);

   int multiplier;
   if (digits == 2) multiplier = 100;
   if (digits == 3) multiplier = 1000;
   if (digits == 4) multiplier = 10000;
   if (digits == 5) multiplier = 100000;

   int AvRange;////Only want a non-decimal reading
   double CandleRange;
   for (int cc = 0; cc <= AdrPeriod; cc++)
   {
      CandleRange = ((iHigh(symbol, Chart_TF, cc) - iLow(symbol, Chart_TF, cc)) * multiplier);
      AvRange += CandleRange;
   }//for (int cc = 0; cc <= AdtPeriod; cc++)
   AvRange /= AdrPeriod;
   
   return (AvRange);
}//End double Get_ADR(string symbol)

double Get_Trade_Entry_Points(string symbol, int range, string level)
{
   //Returns the target price for OB\OS
   
   double digits = MarketInfo(symbol, MODE_DIGITS);
   double point = MarketInfo(symbol, MODE_POINT);
   double price;
   double AddRange = (range * point) / 2;
   double SarRange = (range * point) * 70 / 100;
   //Normal
   if (level == high)
   {
      price = NormalizeDouble(iOpen(symbol, Chart_TF, 0) + AddRange, digits);
   }//if (level == high)
   
   //Stop and reverse
   if (level == SAR_High)
   {
      price = NormalizeDouble(iOpen(symbol, Chart_TF, 0) + SarRange, digits);
   }//if (level == SAR_High)
   
   
   //Normal
   if (level == low)
   {
      price = NormalizeDouble(iOpen(symbol, Chart_TF, 0) - AddRange, digits);
   }//if (level == high)
   
   //Stop and reverse
   if (level == SAR_Low)
   {
      price = NormalizeDouble(iOpen(symbol, Chart_TF, 0) - SarRange, digits);
   }//if (level == SAR_Low)
   
   return(price);
   
}//End double Get_Trade_Entry_Points(string symbol, int range, string direction)

void RemovePendingTrades()
{
   //Delete pending trades at the start of each candle. Only called if there are open trades.
   
   while (!IsTradeAllowed() )
   {
      Sleep(100);
   }//while (!IsTradeAllowed() )
   
   for (int cc = OrdersTotal(); cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      if (OrderMagicNumber()==MagicNumber && (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) )      
      {
            bool result = OrderDelete(OrderTicket() );
            if (!result) 
            {               
               cc = OrdersTotal();
            }//if (!result) 
            else 
            {
               Sleep(50);            
               cc++;     
            }//else        
      }//if (OrderMagicNumber()==MagicNumber && (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) )
   }//for (int cc=0; cc<OrdersTotal(); cc++)


}//void RemovePendingTrades()

void ReadBands(string symbol)
{
   //Read the values of the bollinger bands. They are counted 1 - 3 from the top.
   //Sets the value of TradingBand
   
   
   Line1 = iCustom(symbol, BB_TF, "Bands", 20, 0, 2, 1, 1);
   Line2 = iCustom(symbol, BB_TF, "Bands", 20, 0, 1, 1, 1);
   Line3 = iCustom(symbol, BB_TF, "Bands", 20, 0, 2, 0, 1);
   
  
   
   
}//void ReadBands(string symbol)

bool Should_SAR_Trade_Close()
{
   //Trade is already selected, but check.
   //Tell the calling function the trade has closed if it has closed during the function call.
   if (!OrderSelect(TicketNo, SELECT_BY_TICKET) ) return(true);
   if (OrderCloseTime() > 0) return(true);
   
   ReadBands(OrderSymbol() );
   
   if (OrderType() == OP_BUY)
   {
      if (MarketInfo(OrderSymbol(), MODE_ASK) < Line1) return(true);      
   }//if (OrderType() == op_buy)
   
   if (OrderType() == OP_SELL)
   {
      if (MarketInfo(OrderSymbol(), MODE_BID) > Line3) return(true);      
   }//if (OrderType() == op_buy)
   
   //Got this far, so trade does not need closing
   return(false);

}//bool Should_SAR_Trade_Close()


//+------------------------------------------------------------------+
//| expert Start function                                            |
//+------------------------------------------------------------------+

int start()
{
    
   if (RobotDisabled )
   {
      Comment("The robot has been suspended. Reason: ", DisabledMessage);
      return;
   }//if (RobotDisabled )


   //Read the average daily trade values at the start of each candle, to cut down on cpu processing use
   if (OldBars != iBars(NULL, Chart_TF) )
   {
      //Remove pending trades
      if (OrdersTotal() > 0) RemovePendingTrades();
      Comment("Waiting for all the new candles to form");
      bool done = false;
      while (!done)
      {
         done = true;
         for (int cc = 0; cc < ArraySize(TradePair); cc++)
         {
            if (dBars[cc] != iBars(TradePair[cc], Chart_TF) )
            {
               dBars[cc] = iBars(TradePair[cc], Chart_TF);
               done = false;
            }//if (dBars[cc] != iBars(TradePair[cc], Chart_TF) )
            
         }//for (int cc = 0; cc < ArraySize(TradePair); cc++)
      }//while (!done)
      
      for (cc = 0; cc < ArraySize(TradePair); cc++)
      {
         Adr[cc] = Get_ADR(TradePair[cc] );
         TradeEntryHigh[cc] = Get_Trade_Entry_Points(TradePair[cc], Adr[cc], high);
         TradeEntryLow[cc] = Get_Trade_Entry_Points(TradePair[cc], Adr[cc], low);
         SarEntryHigh[cc] = Get_Trade_Entry_Points(TradePair[cc], Adr[cc], SAR_High);
         SarEntryLow[cc] = Get_Trade_Entry_Points(TradePair[cc], Adr[cc], SAR_Low);
         GvName = gv + TradePair[cc];
         GlobalVariableDel(GvName);
      }//for (int cc = 0; cc < ArraySize(TradePair); cc++)
      OldBars = iBars(NULL, Chart_TF);
   }//if (OldBars !> iBars(NULL, PERIOD_D1) )
   

    GetPosition();
    if(NoOfTrades > 0) ManageTrades();
    
    //Check Friday close
   if (FridayClose)
   {
      ClosedForFriday = false;
      if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 5)
      {
         ClosedForFriday = true;
         return;
      }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
   }//if (FridayClose)
   
   //Check Saturday close for Aitipodeans
   if (SaturdayClose)
   {
      ClosedForSaturday = false;
      if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 6)
      {
         ClosedForSaturday = true;
         return;
      }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
   }//if (Saturday)
   
    
/*    //Trade disable conditions
    if (NewsExist() )
    {
         ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading disabled because of news event");
         DisplayUserFeedback();
    }//if (NewsExists)
*/    

   if (StopTrading)
   {
      Comment("You have suspended trading. I shall continue to monitor open trades.");
      return;
   }//if (StopTrading)
   
   //Trading hours
   bool TradeHour = false;
   if ((Hour()>=start_hourm && Hour()<end_hourm) || (Hour()>=start_houre && Hour()<end_houre)) TradeHour = true;
   if (!TradeHour)
   {
      Comment(Gap, "Trading suspended - outside trade hours. Continuing to monitor open trades.");
      return;
   }//if (!TradeHour)

    //Look for trading opportunities
    for(cc = 0; cc < ArraySize(TradePair); cc++)
    {

       if(NoOfTrades >= MaxTradesAllowed) break;
       if (!IsTradeAllowed())
       {
            Comment("Trading disabled by the criminal pillock. Please wait for him to get out of bed.");
            return;
       }//if (!IsTradeAllowed)
        
       if(iClose(TradePair[cc],0,0) > 0)
       {      
            bool TradeExists = DoesTradeExist(TradePair[cc]);
            
            double AdrVal = Get_ADR(TradePair[cc]);
            if (AdrVal < Min_ADR) continue;
            //Normal entry levels at price +- 50% adr
            double NormalEntryHigh = Get_Trade_Entry_Points(TradePair[cc], AdrVal, high);
            double NormalEntryLow = Get_Trade_Entry_Points(TradePair[cc], AdrVal, low);
            //Stop and revererse levels at price +- 70%
            double SarEntryHigh = Get_Trade_Entry_Points(TradePair[cc], AdrVal, SAR_High);
            double SarEntryLow = Get_Trade_Entry_Points(TradePair[cc], AdrVal, SAR_Low);
            
            
            double ask = MarketInfo(TradePair[cc], MODE_ASK);
            double bid = MarketInfo(TradePair[cc], MODE_BID);
            if (IsTradeAllowed() && TradeShort)
            {                    
               //Normal trade at candle open price + 50% adr
               if(bid >= NormalEntryHigh && bid < SarEntryHigh && !TradeExists)//Pending sell stopade
               {                    
                  SendOrder(TradePair[cc],OP_SELLSTOP, Lots, exhaustion);                   
               }//if(ask >= TradeEntryHigh[])//Pending buy stopade
               
               //Stop and reverse trade at candle open price + 70% ADR
               if(bid >= SarEntryHigh )
               {                    
                  //Check to see if there is an open trade
                  if (TradeExists)
                  {
                     //It does, so re-select just in case
                     if (!OrderSelect(TicketNo, SELECT_BY_TICKET) ) continue;
                     //Delete the trade if it is an exhaustion pending
                     if (OrderType() == OP_SELLSTOP && OrderCloseTime() == 0) OrderDelete(TicketNo);
                     if (OrderType() == OP_SELL) OrderClose(TicketNo, OrderLots(), OrderClosePrice(), 100);
                     if (OrderType() == OP_BUY) continue;//SAR Trade already open
                  }//if (TradeExists)
                  //Only gets this far if there is no sar trade already open, so check that there has not already
                  //been a breakout trade
                  GvName = gv + TradePair[cc];
                  if (GlobalVariableCheck(GvName) || !TradeLong) continue;
                  //Got this far, so a sar trade needs sending
                  SendOrder(TradePair[cc],OP_BUY,Lots, sar);
                  GlobalVariableSet(GvName, 0);
               }//if(ask >= TradeEntryHigh[])//Pending buy stopade
               
               
            }//if (IsTradeAllowed)
                  
           
            if (IsTradeAllowed() && TradeLong)
            {                    
               //Normal trade at candle open price - 50% adr
               if(ask <= NormalEntryLow && ask > SarEntryLow && !TradeExists)//Pending buy stop
               {
                 SendOrder(TradePair[cc],OP_BUYSTOP,Lots, exhaustion);                       
               }//if(bid < TradeEntryLow[])//Pending sell stop
               
               
               //Stop and reverse trade at candle open price - 70% ADR
               if(ask <= SarEntryHigh )
               {                    
                  //Check to see if there is an open trade
                  if (TradeExists)
                  {
                     //It does, so re-select just in case
                     if (!OrderSelect(TicketNo, SELECT_BY_TICKET) ) continue;
                     //Delete the trade if it is an exhaustion pending
                     if (OrderType() == OP_BUYSTOP && OrderCloseTime() == 0) OrderDelete(TicketNo);
                     if (OrderType() == OP_BUY) OrderClose(TicketNo, OrderLots(), OrderClosePrice(), 100);
                     if (OrderType() == OP_SELL) continue;//SAR Trade already open
                  }//if (TradeExists)
                  //Only gets this far if there is no sar trade already open, so check that there has not already
                  //been a breakout trade
                  GvName = gv + TradePair[cc];
                  if (GlobalVariableCheck(GvName) || !TradeShort) continue;
                  //Got this far, so a sar trade needs sending
                  SendOrder(TradePair[cc],OP_SELL,Lots, sar);
                  GlobalVariableSet(GvName, 1);
               }//if(ask >= TradeEntryHigh[])//Pending buy stopade
               
               
               
            }//if (IsTradeAllowed)        
      
         }//if(iClose(TradePair[cc],0,0) > 0)
      
      }//for(int cc = 0; cc < ArraySize(TradePair); cc++)
    
    DisplayUserFeedback();
      
    return(0);

}//End start()


